// DrawPoints.cpp : implementation file
//

#include "stdafx.h"
#include "drill2nc1.h"
#include "DrawPoints.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#define BG_COLOR             RGB(0x40, 0x00, 0x00)
#define PCB_COLOR            RGB(0x00, 0x40, 0x00)
#define LINE_CLR_NORMAL      RGB(0x20, 0x20, 0x40)
#define LINE_CLR_HL          RGB(0x80, 0x40, 0x40)
//RGB(0xFF, 0x00, 0x00)
#define LINE_STYLE_NORMAL    PS_SOLID
#define LINE_STYLE_HL        PS_DOT
#define BORDER_WIDTH         5
#define BORDER_HEIGHT        5
#define DOT_COLOR_NORM       RGB(0x00, 0x80, 0x00)
#define DOT_COLOR_HL         RGB(0xFF, 0xFF, 0x00)
#define DOT_COLOR_SEL        RGB(0xFF, 0x00, 0x00)

/////////////////////////////////////////////////////////////////////////////
// CDrawPoints

CDrawPoints::CDrawPoints()
:m_IsMemReady(false)
{
}

CDrawPoints::~CDrawPoints()
{
}


BEGIN_MESSAGE_MAP(CDrawPoints, CStatic)
	//{{AFX_MSG_MAP(CDrawPoints)
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDrawPoints message handlers

void CDrawPoints::OnPaint() 
{
	CDC *dc = GetDC();
	if (!m_IsMemReady)
	{
		m_MemDC.CreateCompatibleDC(dc);
		GetClientRect(m_MemRect);
		m_MemBitmap.CreateCompatibleBitmap(dc, m_MemRect.Width(), m_MemRect.Height());
		m_MemDC.SelectObject(&m_MemBitmap);
		m_MemDC.FillSolidRect(m_MemRect, BG_COLOR);
		m_IsMemReady = true;
	}
	dc->BitBlt(0, 0, m_MemRect.Width(), m_MemRect.Height(), &m_MemDC, 0, 0, SRCCOPY);
	ValidateRect(NULL);
	ReleaseDC(dc);
}

void CDrawPoints::DrawPath(CNCToolList *tl)
{
	CRect rt = m_MemRect;
	m_MemDC.FillSolidRect(rt, BG_COLOR);
	rt.DeflateRect(BORDER_WIDTH, BORDER_HEIGHT, BORDER_WIDTH, BORDER_HEIGHT);
	if ((tl->m_BottomRight.m_X > tl->m_TopLeft.m_X)
		&& (tl->m_BottomRight.m_Y > tl->m_TopLeft.m_Y))
	{
		double kx = ((double)rt.Width() )/(tl->m_BottomRight.m_X - tl->m_TopLeft.m_X);
		double ky = ((double)rt.Height())/(tl->m_BottomRight.m_Y - tl->m_TopLeft.m_Y);
		int x0=0;
		int y0=0;
		if (kx>ky)
		{
			x0 = (rt.Width() -(int)(ky*(tl->m_BottomRight.m_X - tl->m_TopLeft.m_X)))>>1;
			kx = ky;
		}
		else
		{
			y0 = (rt.Height()-(int)(kx*(tl->m_BottomRight.m_Y - tl->m_TopLeft.m_Y)))>>1;
			ky = kx;
		}
		rt.DeflateRect(x0, y0, x0, y0);
		m_MemDC.FillSolidRect(rt, PCB_COLOR);
		x0 += BORDER_WIDTH;
		y0 += BORDER_HEIGHT;
#define NC_X0 (tl->m_TopLeft.m_X)
#define NC_Y0 (tl->m_TopLeft.m_Y)
		CPen p_norm(LINE_STYLE_NORMAL, 1, LINE_CLR_NORMAL);
		CPen p_hl  (LINE_STYLE_HL    , 1, LINE_CLR_HL);
		double x, y;
		int ix, iy;
		m_MemDC.MoveTo(rt.TopLeft());
		COLORREF dot_clr;
		for (int ti=tl->GetSize()-1; ti>=0; ti--)
		{
			if ((*tl)[ti]->GetSize())
			{
				if (ti == tl->m_SelTool)
				{
					// highlight pen
					m_MemDC.SelectObject(p_hl);
					dot_clr = DOT_COLOR_HL;
				}
				else
				{
					// normal pen
					m_MemDC.SelectObject(p_norm);
					dot_clr = DOT_COLOR_NORM;
				}
				for (int pi=(*tl)[ti]->GetSize()-1; pi>=0; pi--)
				{
					x = ((*((*tl)[ti]))[pi].m_X-NC_X0)*kx;
					y = ((*((*tl)[ti]))[pi].m_Y-NC_Y0)*ky;
					ix = x0+(int)x;
					iy = y0+(int)y;
					m_MemDC.FillSolidRect(ix-1, iy-1, 3, 3, ((ti == tl->m_SelTool) && (pi == tl->m_SelPoint))?DOT_COLOR_SEL:dot_clr);
					m_MemDC.SetBkColor(PCB_COLOR);
					m_MemDC.LineTo(ix, iy);
				}
			}
		}
	}


	RedrawWindow();
}
