// NCPoint.cpp: implementation of the CNCPoint class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "drill2nc1.h"
#include "NCPoint.h"
#include "math.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

DIST_MEASURE_METHOD m_DistMeasureMethod = DMM_LINEAR;

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CNCPoint::CNCPoint()
:m_X(0), m_Y(0)
{
}

CNCPoint::CNCPoint(NCCOORD x, NCCOORD y)
:m_X(x), m_Y(y)
{
}

CNCPoint::~CNCPoint()
{

}

CNCPoint CNCPoint::operator =(CNCPoint src)
{
	m_X = src.m_X;
	m_Y = src.m_Y;
	return src;
}

NCCOORD CNCPoint::operator *(CNCPoint to)
{
	NCCOORD dist;
#define d_abs(d_val) ((d_val>=0)?(d_val):(-(d_val)))
#define d_max(d_val1, d_val2) ((d_val1>=d_val2)?(d_val1):(d_val2))
	if (m_DistMeasureMethod == DMM_LINEAR) dist = d_max(d_abs(m_X-to.m_X), d_abs(m_Y-to.m_Y));
	else dist = sqrt((m_X-to.m_X)*(m_X-to.m_X)+(m_Y-to.m_Y)*(m_Y-to.m_Y));
	return dist;
}

void CNCPoint::SetDmm(DIST_MEASURE_METHOD dmm)
{
	m_DistMeasureMethod = dmm;
}
