// NCTool.cpp: implementation of the CNCTool class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "drill2nc1.h"
#include "NCTool.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

static int tid = 0;


CNCTool::CNCTool()
:m_Index(-1), m_Dia(0), m_IsSel(false)
{
	m_tid = tid++;
	TRACE("+++         create tool     (tid %3d) %08p\n", m_tid, this);
}

CNCTool::CNCTool(int index, double dia)
:m_Index(index), m_Dia(dia), m_IsSel(false)
{
	m_tid = tid++;
	TRACE("+++         create tool #%02d (tid %3d) %08p\n", m_Index, m_tid, this);
}

CNCTool::~CNCTool()
{
	TRACE("-           del    tool #%02d (tid %3d) %08p\n", m_Index, m_tid, this);
}

void CNCTool::TSet(int index, double dia)
{
	m_Index = index;
	m_Dia = dia;
	TRACE("            set    tool #%02d (tid %3d) %08p\n", m_Index, m_tid, this);
}

void CNCTool::TSet(int index)
{
	m_Index = index;
	TRACE("            set    tool #%02d (tid %3d) %08p\n", m_Index, m_tid, this);
}

void CNCTool::TSet(double dia)
{
	m_Dia = dia;
}

void CNCTool::operator =(CNCTool t)
{
	m_Index = t.m_Index;
	m_Dia = t.m_Dia;
	m_IsSel = t.m_IsSel;
	*((CNCPointSequence*)this)=t;
	TRACE("            eq     tool #%02d (tid %3d) %08p\n", m_Index, m_tid, this);
}

void CNCTool::Merge(CNCTool t)
{
	for (int pi=0; pi<t.GetSize(); pi++) Add(t[pi]);
}

void CNCTool::Clear()
{
	m_Index = -1;
	m_Dia = 0;
	m_IsSel = false;
}
