// NCToolList.h: interface for the CNCToolList class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_NCTOOLLIST_H__5D328697_311B_4719_818D_6C471113A287__INCLUDED_)
#define AFX_NCTOOLLIST_H__5D328697_311B_4719_818D_6C471113A287__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "NCTool.h"

class CNCToolList  
{
public:
	int m_ToolCount;
	CNCTool *m_ToolList;
	int m_MemCount;
	void IncMem();
public:
	CNCTool* GetAt(int pos);
	void CalcRect();
	int m_SelTool;
	int m_SelPoint;
	CNCPoint m_TopLeft;
	CNCPoint m_BottomRight;
	int Add(CNCTool p); // add new tool
	void Insert(int pos, CNCTool p); // insert tool into position
	void Delete(int pos); // delete tool at position
	void DeleteAll(); // clear tool list
	void Swap(int a, int b); // exchange tools at positions
	void Set(int pos, CNCTool p); // set tool value at position
	int GetSize(); // returns tool count
	int Find(int index); // searchs for tool. returns position when tool found and -1 when none
	CNCTool* operator[](int pos);

	CNCToolList();
	virtual ~CNCToolList();

};

#endif // !defined(AFX_NCTOOLLIST_H__5D328697_311B_4719_818D_6C471113A287__INCLUDED_)
